Unit ftfrr_p;
interface
uses
SysUtils, Math, { Delphi }
LStruct, Lfunc, FTF1C_p;

procedure ftfrr(var P :Real; N1 :Integer; N2 :Integer;
                var A :Array of Real; var B :Array of Real;
                var X :Array of Real);

implementation

procedure ftfrr(var P :Real; N1 :Integer; N2 :Integer;
                var A :Array of Real; var B :Array of Real;
                var X :Array of Real);
var
N,I,J,K :Integer;
R,Q,T,C,S,U :Real;
const
SYS001 :Real = 3.1415926535897932384626433832795;
label
_1,_2,_3,_4,_5,_6,_7;
begin
N := N1-1;
if ( P ) < 0
 then goto _3
 else if ( P ) > 0
       then goto _1
       else goto _7;
_1:
R := 1.0/(N);
for I:=1 to N do
 begin
  J := I+I;
  B[I-1] := X[J-1]*R;
_2:
  A[I-1] := X[J-2]*R;
 end;
FTF1C(A,B,N,1,1,P);
A[N1-1] := A[0]-B[0];
A[0] := A[0]+B[0];
B[0] := 0;
_3:
Q := SYS001/(N);
J := N;
K := Trunc( N/2 );
for I:=2 to K do
 begin
  T := Q*(I-1);
  S := Sin(T);
  C := -Cos(T);
  T := A[J-1]-A[I-1];
  U := B[J-1]+B[I-1];
  R := U*C-T*S;
  T := T*C+U*S;
  U := A[J-1]+A[I-1];
  A[I-1] := (U-R)*0.5;
  A[J-1] := (U+R)*0.5;
  U := B[J-1]-B[I-1];
  B[I-1] := (T+U)*0.5;
  B[J-1] := (T-U)*0.5;
_4:
  J := J-1;
 end;
if ( P ) < 0
 then goto _5
 else if ( P ) > 0
       then goto _7
       else goto _7;
_5:
B[0] := 0.5*(A[0]-A[N1-1]);
A[0] := 0.5*(A[0]+A[N1-1]);
FTF1C(A,B,N,1,1,P);
for I:=1 to N do
 begin
  J := I+I;
  X[J-1] := B[I-1];
_6:
  X[J-2] := A[I-1];
 end;
_7:
end;

end.
